var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { useCallback } from 'react';
import { Select as AntdSelect } from 'antd';
import { useTranslation } from 'react-i18next';
import { Labelled } from '../labelled';
import { SelectCSS } from './select.style';
export const Select = (_a) => {
    var { options = [], allowEmpty, onChange = () => void 0, onAccept = () => void 0, defaultValue, onSelect } = _a, props = __rest(_a, ["options", "allowEmpty", "onChange", "onAccept", "defaultValue", "onSelect"]);
    const { t } = useTranslation();
    const handleChange = useCallback((value) => {
        onChange(value);
        onAccept();
    }, [onChange, onAccept]);
    return (_jsxs(AntdSelect, Object.assign({ css: SelectCSS, size: "small", onChange: handleChange }, props, { children: [allowEmpty && (_jsx(AntdSelect.Option, { value: null, children: t('inspector.components.select.option.none.title') }, 0)), options.map((option) => (typeof option === 'object'
                ? (_jsx(AntdSelect.Option, { value: option.value, disabled: option.disabled, children: option.title }, option.value))
                : (_jsx(AntdSelect.Option, { value: option, children: option }, option))))] })));
};
export const LabelledSelect = (_a) => {
    var { label } = _a, props = __rest(_a, ["label"]);
    return (_jsx(Labelled, { label: label, children: _jsx(Select, Object.assign({}, props)) }));
};
